#include <stdio.h>
#include <ctype.h>

void error(char *errstrg1, char *errstrg2);

main(int argc, char **argv)
{
	int c, i, j, tab = 4;
	FILE *infp = stdin, *outfp = stdout;

	if (argc == 1)
		;
	else if (argc == 2) {
		if (argv[1][0] == '-' && isdigit(argv[1][1]))
			tab = argv[1][1] - '0';
		else {
			if ((infp = fopen(argv[1], "r")) == NULL)
				error("couldn't acces ", argv[1]);
		}
	} else if (argc == 3) {
		if (argv[1][0] == '-' && isdigit(argv[1][1])) {
			tab = argv[1][1] - '0';
			if ((infp = fopen(argv[2], "r")) == NULL)
				error("couldn't acces ", argv[2]);
		} else {
			if ((infp = fopen(argv[1], "r")) == NULL)
				error("couldn't acces ", argv[1]);
			if ((outfp = fopen(argv[2], "w")) == NULL)
				error("couldn't acces ", argv[2]);
		}
	} else if (argc == 4) {
		if (argv[1][0] == '-' && isdigit(argv[1][1])) {
			tab = argv[1][1] - '0';
			if ((infp = fopen(argv[2], "r")) == NULL)
				error("couldn't acces ", argv[1]);
			if ((outfp = fopen(argv[3], "w")) == NULL)
				error("couldn't acces ", argv[2]);
		}
	} else
		error("too many parameters", "");

	i = 0;
	while ((c=getc(infp)) != EOF) {
		if (c == '\n') {
			i = 0;
			putc(c, outfp);
		} else if (c == '\t') {
			i += j = tab - i % tab;
			fprintf(outfp, "%.*s", j, "                                        ");
		} else {
			putc(c, outfp);
			i++;
		}
	}
};

void error(char *errstrg1, char *errstrg2)
{
	fprintf(stderr, "Error: %s%s\n", errstrg1, errstrg2);
	fprintf(stderr, "Usage: detab [-n] [infile [outfile]]\n");
	fprintf(stderr, "       n: decimal tabwidth\n");
	exit(2);
}
