/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Pascal-Programm:     Vera Kell                 Aachen, 31.07.1989         */
/*                                                                            */
/*  ANSI-C  Version:     Raphael M. Grochtmann     Aachen, 31.08.1990         */
/*                                                                            */
/*                                                                            */
/******************************************************************************/


#include <stdio.h>

#include "ext.h"
#include "list.h"

boolean epstrans;
char epsletter;
boolean withoutlaststate;
int  laststate;


#define CHECK_EOF	\
	if (feof(fp)) {	\
		printf("*** ERROR: unexpected end of file in %s *** \n", full_filename); \
		exit(1); }


void ChangeAmoreFile(ptupel *a)
{
	FILE *fp;
	int j, help, count, q1, q2,last;
	char c, s[5];
	ptupel ahelp;
	ptransition adelta;
	pinteger aqe;

	if ((fp = fopen(full_filename, "r")) == NULL) {
		printf("*** ERROR: could not open %s *** \n", full_filename);
		exit(1);
	}
	ahelp.q0 = TRUE;
	Clearset(ahelp.s);
	ahelp.ssize = ahelp.qa = 0;
	ahelp.delta = NULL;
	ahelp.qe = NULL;
	CHECK_EOF; fscanf(fp, "%d\n", &ahelp.q);	/* Anzahl der Zustaende */
	CHECK_EOF; fscanf(fp, "%d\n", &ahelp.ssize);	/* Anzahl der Symbole */
	CHECK_EOF; fscanf(fp, "%d\n", &help);	/* Alphabetmenge aufbauen */
        CHECK_EOF; fscanf(fp, "%d\n", &last);   /* letzter Zustand ist "uber */
        if (help == 1) {ahelp.ssize++;epstrans=TRUE;}
        else epstrans=FALSE;
        if(last == 1){laststate=ahelp.q;withoutlaststate=TRUE;}
        else         {laststate=ahelp.q+2;withoutlaststate=FALSE;}
        count = ahelp.ssize;
        c = 'a';
        for(j=1; j <= count; j++,c++)Incl(ahelp.s, c);
        if(epstrans) epsletter=--c;
	CHECK_EOF; fscanf(fp, "%d\n", &ahelp.qa);		/* Anfangszustand */
	for (j=1; j <= ahelp.q; j++) {					/* Endzustaende */
		CHECK_EOF; fscanf(fp, "%s", s);
		c = s[0];
		if (c != '0'  &&  c != 'F')
			if (ahelp.qe == NULL) {
				IntListBeg(&ahelp.qe, j);
				aqe = ahelp.qe;
			} else
				IntListAddEnd(&aqe, j);
	}
	CHECK_EOF; fscanf(fp, "%d\n", &count);			/* Anzahl Transitionen */
	for (j=1; j <= count; j++) {					/* Transitionen */
		CHECK_EOF; fscanf(fp, "%d\n", &q1); 
		CHECK_EOF; fscanf(fp, "%d\n", &q2);
		CHECK_EOF; fscanf(fp, "%d\n", &help); 
		if (help != 0)
			c = help + 96;							/* 96 == 'a' - 1 */
		else
			c = ' ';
		if (ahelp.delta == NULL) {
			TransListBeg(&ahelp.delta, q1, q2, c);
			adelta = ahelp.delta;
		} else
			TransListAddEnd(&adelta, q1, q2, c);
	}
   *a = ahelp;
} /*ChangeAmoreFile*/
