/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Pascal-Programm:     Vera Kell                 Aachen, 31.07.1989         */
/*                                                                            */
/*  ANSI-C  Version:     Raphael M. Grochtmann     Aachen, 31.07.1990         */
/*                                                                            */
/*  XWindows Version:    Raphael M. Grochtmann     Aachen, 31.08.1990         */
/*                                                                            */
/*                                                                            */
/*      Graphik Routinen basierend auf den XLib Graphik-Primitiven            */
/******************************************************************************/

/* Das XLib-Koordinatensystem hat seinen Ursprung oben links, d.h. es
   muessen alle y-Werte sowie die Winkel umgedreht werden */



#include "main.h"



/* Deklaration globaler Variablen, Definition in xmain.c */
extern gc;
extern display;
extern drawable;



void CLine(x1, y1, x2, y2)
int x1, y1, x2, y2;
{
	y1 = YGRMAX - y1;
	y2 = YGRMAX - y2;
	XDrawLine(display, drawable, gc, x1, y1, x2, y2);
}



void CCircle(x, y, r)
int x, y, r;
{
	y = YGRMAX - y;
	XDrawArc(display, drawable, gc, x - r, y - r, 2 * r, 2 * r, 0, 360 * 64);
}



void CArc(x, y, r, beg, end)
int x, y, r, beg, end;
{
	y = YGRMAX - y;
	if (beg <= end)					/* end wird jetzt 'Winkelbreite' des Arcs */
		end = end - beg;
	else
		end = 360 - (beg - end);
	XDrawArc(display, drawable, gc, x - r, y - r, 2 * r, 2 * r, beg * 64, end * 64);
}



void CText(x, y, str)
int x, y; char *str;
{
	y = YGRMAX - y;
	XDrawString(display, drawable, gc, x, y, str, strlen(str));
}
